/**
 * @namespace flexygo.crm
 */
declare namespace flexygo.crm {
    /**
    * Enables Actuaciones edit form .
    * @method editLightActuaciones
    * @param {JQuery} itm - item clicked on.
    * @param {number} clasif - classification value.
    * @param {string} id -identificador del objeto.
    * @param {string} objectname - object name.
    */
    function editLightActuaciones(itm: JQuery, clasif: number, id: string, objectname: string, otherId?: string): void;
    /**
    * injects the filter of an object module list, into a module of the same type. When the user filtering the collection, inject the sql filter and presets filters, then execute refresh action in a depending module.
    * @method moduleListFilterCapture
    * @param {string} dependingModuleName - name of the depending module object list.
    * @param {string} parentModuleName - name of the parent module object list.
    */
    function moduleListFilterCapture(dependingModuleName: string, parentModuleName: string): void;
    /**
    * Change offer state.
    * @method crmOferta_ActualizaEstado
    * @param {number} IdOferta - offer identifier.
    * @param {number} Revision - offer rev identifier.
    * @param {number} EstadoActual - actual offer state number.
    * @param {number} NuevoEstado - new offer state number.
    */
    function crmOferta_ActualizaEstado(e: any, IdOferta: number, Revision: number, IdTipoCliente: number, EstadoActual: number, NuevoEstado: number): void;
    /**
    * Change opportunity state.
    * @method crmOferta_ActualizaEstado
    * @param {number} IdOferta - offer identifier.
    * @param {number} Revision - offer rev identifier.
    * @param {number} EstadoActual - actual offer state number.
    * @param {number} NuevoEstado - new offer state number.
    */
    function crmOportunidad_ActualizaEstado(e: any, IdOportunidad: number, Estadoactual: number, NuevoEstado: number): void;
    /**
   * Change client state.
   * @method crmCliente_ActualizaEstadoComercial
   * @param {number} IdCliente - client identifier.
   * @param {number} EstadoActual - actual client comm state number.
   * @param {number} NuevoEstado - new client comm state number.
   */
    function crmCliente_ActualizaEstadoComercial(e: any, IdCliente: string, Estadoactual: number, NuevoEstado: number): void;
    /**
    * Comprobar si hay un cliente con el mismo email.
    * @method crmCliente_ComprobarEmail
    * @param {number} cantreg - cantidad de clientes que se encontrón coincidencia.
    * @param {string} email - el email en cuestión.
    * @param {string} idcliente - el cliente en cuestión, viene vacío si estamos creando uno nuevo.
    */
    function crmCliente_ComprobarEmail(cantreg: number, email: string, idcliente: string): void;
    /**
    * Comprobar si hay un cliente con el mismo teléfono.
    * @method crmCliente_ComprobarTel
    * @param {number} cantreg - cantidad de clientes que se encontrón coincidencia.
    * @param {string} tel - el teléfono en cuestión.
    * @param {string} idcliente - el cliente en cuestión, viene vacío si estamos creando uno nuevo.
    */
    function crmCliente_ComprobarTel(cantreg: number, tel: string, idcliente: string): void;
    /**
    * Montar gráfica compañias.
    * @method crmGrafica_Compañias
    * @param {number} IdCompañia - Identificador de la compañia.
    */
    function crmGrafica_Compañias(IdCompañia: number): void;
    /**
    * Filtramos la lista en función al valor del combo.
    * @method crmTimelineAct_CboEmpChange
    * @param {any} e - control combo múltiple con identificadres de empleado.
    */
    function crmTimelineAct_CboEmpChange(e: any, modulename: string): void;
    /**
    * Expandimos el contenido del timeline.
    * @method crmTimelineAct_Expandir
    * @param {any} e - control.
    */
    function crmTimelineAct_Expandir(e: any): void;
    /**
    * Expandimos el contenido del timeline.
    * @method crmTimelineAct_ZoomAsunto
    * @param {any} e - control.
    */
    function crmTimelineAct_ZoomAsunto(e: any): void;
    /**
    * Expandimos el contenido del timeline.
    * @method crmTimelineAct_ZommAll
    * @param {any} e - control.
    */
    function crmTimelineAct_ZommAll(e: any): void;
    function crmVerTodasLasActuaciones(e: any, filtro: string, defaults: string, target: string): void;
    function crmFiltrarAgendaPorTipo(e: any): void;
    function getTokens(): void;
    function getGoogleTokens(): void;
    function desactivateFilter(Valor: any, FilIdDoc: any, IdFiltro: any): void;
}
